import os
import re
import subprocess

from setuptools import Extension, find_packages, setup
import torch
from typing import Optional, Union
from pathlib import Path

if torch.__version__ >= '1.5':
    from torch.utils.cpp_extension import ROCM_HOME
    if ((torch.version.hip is not None) and (ROCM_HOME is not None)):
        CUDA_HOME = ROCM_HOME

# ninja build does not work unless include_dirs are abs path
this_dir = os.path.dirname(os.path.abspath(__file__))
build_cuda_ext = False 
build_hip_ext = True 
ext_modules = []

if int(os.environ.get('NO_CUDA_EXT', '0')) == 1:
    build_cuda_ext = False
    
if int(os.environ.get('NO_HIP_EXT', '0')) == 1:
    build_hip_ext = False


def get_cuda_bare_metal_version(cuda_dir):
    if build_cuda_ext == True:
        raw_output = subprocess.check_output([cuda_dir + "/bin/nvcc", "-V"], universal_newlines=True)
        output = raw_output.split()
        release_idx = output.index("release") + 1
    else:  
        raw_output = subprocess.check_output([cuda_dir + "/bin/hipcc", "--version"], universal_newlines=True)
        output = raw_output.split()
        release_idx = output.index("version:") + 1
    release = output[release_idx].split(".")
    bare_metal_major = release[0]
    bare_metal_minor = release[1][0]

    return raw_output, bare_metal_major, bare_metal_minor


def check_cuda_torch_binary_vs_bare_metal(cuda_dir):
    raw_output, bare_metal_major, bare_metal_minor = get_cuda_bare_metal_version(cuda_dir)
    if build_cuda_ext == True:
        torch_binary_major = torch.version.cuda.split(".")[0]
        torch_binary_minor = torch.version.cuda.split(".")[1]
    else:
        torch_binary_major = torch.version.hip.split(".")[0]
        torch_binary_minor = torch.version.hip.split(".")[1]

    print("\nCompiling cuda extensions with")
    print(raw_output + "from " + cuda_dir + "/bin\n")

    if bare_metal_major != torch_binary_major:
        print(f'The detected CUDA version ({raw_output}) mismatches the version that was used to compile PyTorch '
              f'({torch.version.cuda}). CUDA extension will not be installed.')
        return False

    if bare_metal_minor != torch_binary_minor:
        print("\nWarning: Cuda extensions are being compiled with a version of Cuda that does "
              "not match the version used to compile Pytorch binaries.  "
              f"Pytorch binaries were compiled with Cuda {torch.version.cuda}.\n"
              "In some cases, a minor-version mismatch will not cause later errors:  "
              "https://github.com/NVIDIA/apex/pull/323#discussion_r287021798. ")
    return True


def check_cuda_availability(cuda_dir):
    if not torch.cuda.is_available():
        # https://github.com/NVIDIA/apex/issues/486
        # Extension builds after https://github.com/pytorch/pytorch/pull/23408 attempt to query
        # torch.cuda.get_device_capability(), which will fail if you are compiling in an environment
        # without visible GPUs (e.g. during an nvidia-docker build command).
        print(
            '\nWarning: Torch did not find available GPUs on this system.\n',
            'If your intention is to cross-compile, this is not an error.\n'
            'By default, Colossal-AI will cross-compile for Pascal (compute capabilities 6.0, 6.1, 6.2),\n'
            'Volta (compute capability 7.0), Turing (compute capability 7.5),\n'
            'and, if the CUDA version is >= 11.0, Ampere (compute capability 8.0).\n'
            'If you wish to cross-compile for a single specific architecture,\n'
            'export TORCH_CUDA_ARCH_LIST="compute capability" before running setup.py.\n')
        if os.environ.get("TORCH_CUDA_ARCH_LIST", None) is None:
            _, bare_metal_major, _ = get_cuda_bare_metal_version(cuda_dir)
            if int(bare_metal_major) == 11:
                os.environ["TORCH_CUDA_ARCH_LIST"] = "6.0;6.1;6.2;7.0;7.5;8.0"
            else:
                os.environ["TORCH_CUDA_ARCH_LIST"] = "6.0;6.1;6.2;7.0;7.5"
        return False

    if cuda_dir is None:
        print("nvcc was not found. CUDA extension will not be installed. If you're installing within a container from "
              "https://hub.docker.com/r/pytorch/pytorch, only images whose names contain 'devel' will provide nvcc.")
        return False
    return True


def append_nvcc_threads(nvcc_extra_args):
    _, bare_metal_major, bare_metal_minor = get_cuda_bare_metal_version(CUDA_HOME)
    if int(bare_metal_major) >= 11 and int(bare_metal_minor) >= 2:
        return nvcc_extra_args + ["--threads", "4"]
    return nvcc_extra_args


def fetch_requirements(path):
    with open(path, 'r') as fd:
        return [r.strip() for r in fd.readlines()]


def fetch_readme():
    with open('README.md', encoding='utf-8') as f:
        return f.read()

def get_sha(root: Union[str, Path]) -> str:
    try:
        return subprocess.check_output(['git', 'rev-parse', 'HEAD'], cwd=root).decode('ascii').strip()
    except Exception:
        return 'Unknown'

def get_abi():
    try:
        command = "echo '#include <string>' | gcc -x c++ -E -dM - | fgrep _GLIBCXX_USE_CXX11_ABI" 
        result = subprocess.run(command, shell=True, capture_output=True, text=True) 
        output = result.stdout.strip() 
        abi = "abi" + output.split(" ")[-1]
        return abi
    except Exception:
        return 'abiUnknown'

def get_version_add(sha: Optional[str] = None) -> str:
    cai_root = os.path.dirname(os.path.abspath(__file__))
    add_version_path = os.path.join(os.path.join(cai_root, "colossalai"), "version.py")
    if sha != 'Unknown':
        if sha is None:
            sha = get_sha(cai_root)
        version = 'git' + sha[:7]

    # abi version
    version += "." + get_abi()

    # dtk version
    if os.getenv("ROCM_PATH"):
        rocm_path = os.getenv('ROCM_PATH', "")
        rocm_version_path = os.path.join(rocm_path, '.info', "rocm_version")
        with open(rocm_version_path, 'r',encoding='utf-8') as file:
            lines = file.readlines()
        rocm_version=lines[0][:-2].replace(".", "")
        version += ".dtk" + rocm_version

    # torch version
    version += ".torch" + torch.__version__[:4]

    with open(add_version_path, encoding="utf-8",mode="w") as file:
        file.write("__version__='0.1.13'\n")
        file.write("__dcu_version__='0.1.13+{}'\n".format(version))
    file.close()


def get_version():
    setup_file_path = os.path.abspath(__file__)
    project_path = os.path.dirname(setup_file_path)
    version_txt_path = os.path.join(project_path, 'version.txt')
    version_py_path = os.path.join(project_path, 'colossalai/version.py')

    with open(version_txt_path) as f:
        version = f.read().strip()
        if build_cuda_ext:
            torch_version = '.'.join(torch.__version__.split('.')[:2])
            cuda_version = '.'.join(get_cuda_bare_metal_version(CUDA_HOME)[1:])
            version += f'+torch{torch_version}cu{cuda_version}'
    
    # write version into version.py
    with open(version_py_path, 'w') as f:
        f.write(f"__version__ = '{version}'\n")
        
    if build_hip_ext:
        get_version_add()
        with open(version_py_path, encoding='utf-8') as f:
            exec(compile(f.read(), version_py_path, 'exec'))
        return locals()['__dcu_version__']

    return version


if build_cuda_ext or build_hip_ext:
    build_cuda_ext = check_cuda_availability(CUDA_HOME) and check_cuda_torch_binary_vs_bare_metal(CUDA_HOME)

try:
    import torch
    from torch.utils.cpp_extension import CUDA_HOME, BuildExtension, CUDAExtension
    from fastpt import CUDAExtension
    print("\n\ntorch.__version__  = {}\n\n".format(torch.__version__))
    TORCH_MAJOR = int(torch.__version__.split('.')[0])
    TORCH_MINOR = int(torch.__version__.split('.')[1])

    if TORCH_MAJOR < 1 or (TORCH_MAJOR == 1 and TORCH_MINOR < 10):
        raise RuntimeError("Colossal-AI requires Pytorch 1.10 or newer.\n"
                        "The latest stable release can be obtained from https://pytorch.org/")
except ImportError:
    raise ModuleNotFoundError('torch is not found. You need to install PyTorch before installing Colossal-AI.')


if build_hip_ext:
    # Set up macros for forward/backward compatibility hack around
    # https://github.com/pytorch/pytorch/commit/4404762d7dd955383acee92e6f06b48144a0742e
    # and
    # https://github.com/NVIDIA/apex/issues/456
    # https://github.com/pytorch/pytorch/commit/eb7b39e02f7d75c26d8a795ea8c7fd911334da7e#diff-4632522f237f1e4e728cb824300403ac
    version_dependent_macros = ['-DVERSION_GE_1_1', '-DVERSION_GE_1_3', '-DVERSION_GE_1_5']
    if build_hip_ext:
        hip_macros = ['-DCOLOSSAL_HIP']

    def cuda_ext_helper(name, sources, extra_cuda_flags):
        return CUDAExtension(
            name=name,
            sources=[os.path.join('colossalai/kernel/hip_native/csrc', path) for path in sources],
                             include_dirs=[os.path.join(
                                 this_dir, 'colossalai/kernel/hip_native/csrc/kernels/include')] + [os.path.join(this_dir, 'colossalai/kernel/hip_native/csrc')],
                             extra_compile_args={'cxx': ['-O3'] + version_dependent_macros + hip_macros,
                                                 'nvcc': ['-O3'] + version_dependent_macros + hip_macros + extra_cuda_flags})

    from torch.utils.hipify import hipify_python
    from fastpt import hipify_python
    hipify_python.hipify(
           project_directory=this_dir,
           output_directory=this_dir,
           includes="colossalai/kernel/cuda_native/*",
           show_detailed=True,
           is_pytorch_extension=True,
        )

    cc_flag = []
    
    extra_cuda_flags = ['-lineinfo']
    
    ext_modules.append(
        cuda_ext_helper('colossalai._C.fused_optim', [
            'colossal_C_frontend.cpp', 'multi_tensor_sgd_kernel.hip', 'multi_tensor_scale_kernel.hip',
            'multi_tensor_adam.hip', 'multi_tensor_l2norm_kernel.hip', 'multi_tensor_lamb.hip'], 
        extra_cuda_flags + cc_flag ))
    

    extra_cuda_flags = [
        '-U__HIP_NO_HALF_OPERATORS__', '-U__HIP_NO_HALF_CONVERSIONS__'
    ]

    ext_modules.append(
        cuda_ext_helper('colossalai._C.scaled_upper_triang_masked_softmax',
                        ['scaled_upper_triang_masked_softmax.cpp', 'scaled_upper_triang_masked_softmax_cuda.hip'],
                        extra_cuda_flags + cc_flag))

    ext_modules.append(
        cuda_ext_helper('colossalai._C.scaled_masked_softmax',
                        ['scaled_masked_softmax.cpp', 'scaled_masked_softmax_cuda.hip'], extra_cuda_flags + cc_flag))
    
    ext_modules.append(
        cuda_ext_helper('colossalai._C.moe', ['moe_cuda.cpp', 'moe_hip_kernel.hip'], extra_cuda_flags + cc_flag))

    extra_cuda_flags = []
    
    ext_modules.append(
        cuda_ext_helper('colossalai._C.layer_norm', ['layer_norm_cuda.cpp', 'layer_norm_hip_kernel.hip'],
                        extra_cuda_flags + cc_flag))

    extra_cuda_flags = [
        '-std=c++14', '-U__HIP_NO_HALF_OPERATORS__', '-U__HIP_NO_HALF_CONVERSIONS__', '-U__HIP_NO_HALF2_OPERATORS__',
        '-DTHRUST_IGNORE_CUB_VERSION_CHECK'
    ]

    ext_modules.append(
        cuda_ext_helper('colossalai._C.multihead_attention', [
            'multihead_attention_1d.cpp', 'kernels/cublas_wrappers.hip', 'kernels/transform_kernels.hip',
            'kernels/dropout_kernels.hip', 'kernels/normalize_kernels.hip', 'kernels/softmax_kernels.hip',
            'kernels/general_kernels.hip', 'kernels/hip_util.hip'
        ], extra_cuda_flags + cc_flag))

    extra_cxx_flags = ['-std=c++14', '-lcudart', '-lcublas', '-g', '-Wno-reorder', '-fopenmp', '-march=native']
    ext_modules.append(cuda_ext_helper('colossalai._C.cpu_optim', ['cpu_adam.cpp'], extra_cuda_flags + extra_cxx_flags))
    
    
build_cuda_ext = False
if build_cuda_ext:
    # Set up macros for forward/backward compatibility hack around
    # https://github.com/pytorch/pytorch/commit/4404762d7dd955383acee92e6f06b48144a0742e
    # and
    # https://github.com/NVIDIA/apex/issues/456
    # https://github.com/pytorch/pytorch/commit/eb7b39e02f7d75c26d8a795ea8c7fd911334da7e#diff-4632522f237f1e4e728cb824300403ac
    version_dependent_macros = ['-DVERSION_GE_1_1', '-DVERSION_GE_1_3', '-DVERSION_GE_1_5']

    def cuda_ext_helper(name, sources, extra_cuda_flags, extra_cxx_flags=[]):
        return CUDAExtension(
            name=name,
            sources=[os.path.join('colossalai/kernel/cuda_native/csrc', path) for path in sources],
            include_dirs=[os.path.join(this_dir, 'colossalai/kernel/cuda_native/csrc/kernels/include')],
            extra_compile_args={
                'cxx': ['-O3'] + version_dependent_macros + extra_cxx_flags,
                'nvcc': append_nvcc_threads(['-O3', '--use_fast_math'] + version_dependent_macros + extra_cuda_flags)
            })

    cc_flag = []
    for arch in torch.cuda.get_arch_list():
        res = re.search(r'sm_(\d+)', arch)
        if res:
            arch_cap = res[1]
            if int(arch_cap) >= 60:
                cc_flag.extend(['-gencode', f'arch=compute_{arch_cap},code={arch}'])

    extra_cuda_flags = ['-lineinfo']

    ext_modules.append(
        cuda_ext_helper('colossalai._C.fused_optim', [
            'colossal_C_frontend.cpp', 'multi_tensor_sgd_kernel.cu', 'multi_tensor_scale_kernel.cu',
            'multi_tensor_adam.cu', 'multi_tensor_l2norm_kernel.cu', 'multi_tensor_lamb.cu'
        ], extra_cuda_flags + cc_flag))

    extra_cuda_flags = [
        '-U__CUDA_NO_HALF_OPERATORS__', '-U__CUDA_NO_HALF_CONVERSIONS__', '--expt-relaxed-constexpr',
        '--expt-extended-lambda'
    ]

    ext_modules.append(
        cuda_ext_helper('colossalai._C.scaled_upper_triang_masked_softmax',
                        ['scaled_upper_triang_masked_softmax.cpp', 'scaled_upper_triang_masked_softmax_cuda.cu'],
                        extra_cuda_flags + cc_flag))

    ext_modules.append(
        cuda_ext_helper('colossalai._C.scaled_masked_softmax',
                        ['scaled_masked_softmax.cpp', 'scaled_masked_softmax_cuda.cu'], extra_cuda_flags + cc_flag))

    ext_modules.append(
        cuda_ext_helper('colossalai._C.moe', ['moe_cuda.cpp', 'moe_cuda_kernel.cu'], extra_cuda_flags + cc_flag))

    extra_cuda_flags = ['-maxrregcount=50']

    ext_modules.append(
        cuda_ext_helper('colossalai._C.layer_norm', ['layer_norm_cuda.cpp', 'layer_norm_cuda_kernel.cu'],
                        extra_cuda_flags + cc_flag))

    extra_cuda_flags = [
        '-std=c++14', '-U__CUDA_NO_HALF_OPERATORS__', '-U__CUDA_NO_HALF_CONVERSIONS__', '-U__CUDA_NO_HALF2_OPERATORS__',
        '-DTHRUST_IGNORE_CUB_VERSION_CHECK'
    ]

    ext_modules.append(
        cuda_ext_helper('colossalai._C.multihead_attention', [
            'multihead_attention_1d.cpp', 'kernels/cublas_wrappers.cu', 'kernels/transform_kernels.cu',
            'kernels/dropout_kernels.cu', 'kernels/normalize_kernels.cu', 'kernels/softmax_kernels.cu',
            'kernels/general_kernels.cu', 'kernels/cuda_util.cu'
        ], extra_cuda_flags + cc_flag))

    extra_cxx_flags = ['-std=c++14', '-lcudart', '-lcublas', '-g', '-Wno-reorder', '-fopenmp', '-march=native']
    ext_modules.append(cuda_ext_helper('colossalai._C.cpu_optim', ['cpu_adam.cpp'], extra_cuda_flags, extra_cxx_flags))

setup(name='colossalai',
      version=get_version(),
      packages=find_packages(exclude=(
          'benchmark',
          'docker',
          'tests',
          'docs',
          'examples',
          'tests',
          'scripts',
          'requirements',
          '*.egg-info',
      )),
      description='An integrated large-scale model training system with efficient parallelization techniques',
      long_description=fetch_readme(),
      long_description_content_type='text/markdown',
      license='Apache Software License 2.0',
      url='https://www.colossalai.org',
      project_urls={
          'Forum': 'https://github.com/hpcaitech/ColossalAI/discussions',
          'Bug Tracker': 'https://github.com/hpcaitech/ColossalAI/issues',
          'Examples': 'https://github.com/hpcaitech/ColossalAI-Examples',
          'Documentation': 'http://colossalai.readthedocs.io',
          'Github': 'https://github.com/hpcaitech/ColossalAI',
      },
      ext_modules=ext_modules,
      cmdclass={'build_ext': BuildExtension} if ext_modules else {},
      install_requires=fetch_requirements('requirements/requirements.txt'),
      entry_points='''
        [console_scripts]
        colossalai=colossalai.cli:cli
    ''',
      python_requires='>=3.6',
      classifiers=[
          'Programming Language :: Python :: 3',
          'License :: OSI Approved :: Apache Software License',
          'Environment :: GPU :: NVIDIA CUDA',
          'Topic :: Scientific/Engineering :: Artificial Intelligence',
          'Topic :: System :: Distributed Computing',
      ],
      package_data={'colossalai': ['_C/*.pyi']})
